//--------------------------------------------------------------------
//                                                                    
//  Module:       JPrinterDemo                                       
//  Description:  JPrinterDemo
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class JPrinterDemo extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	Panel Panel2;
	com.bristol.jpclient.JpPrintJobCreator JpPrintJobCreator1;
	com.bristol.jpclient.JpPrintJob JpPrintJob1;
	com.bristol.jpclient.JpPrinterProperties JpPrinterProperties1;
	Panel Panel1;
	JDPTabSelectPanel TabPanel1;
	Panel Panel3;
	JDPChart ChartLayout1;
	JDPButtons JDPButtons1;
	Panel Panel4;
	JDPSearchResults ResultList1;
	JDPRichText RichText1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		Panel2 = new Panel();
		JpPrintJobCreator1 = new com.bristol.jpclient.JpPrintJobCreator();
		JpPrintJob1 = JpPrintJobCreator1.createPrintJob();
		JpPrinterProperties1 = new com.bristol.jpclient.JpPrinterProperties();
		Panel1 = new Panel();
		String[] TabPanel1t = new String[1];
		Panel[] TabPanel1p = new Panel[1];
		TabPanel1p[0] = new Panel();
		TabPanel1p[0].setLayout(new BorderLayout());
		TabPanel1t[0] = "Sales Chart";
		TabPanel1 = new JDPTabSelectPanel(user, TabPanel1t, TabPanel1p, "North");
		Panel3 = new Panel();
		ChartLayout1Main();
		String[] JDPButtons1btns = {"Print Chart"};
		int[] JDPButtons1icns = {JDPButton.getIconValue("Printer")};
		JDPButtons1 = new JDPButtons(user, JDPButtons1btns, JDPButtons1icns, JDPButtons.getAlignmentValue("Horizontal"));
		Panel4 = new Panel();
		ResultList1Main();
		RichText1 = new JDPRichText(user);

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("West", Panel2);
		Panel2.setLayout(new BorderLayout());
		Main.add("Center", Panel1);
		Panel1.setLayout(new BorderLayout());
		Panel1.add("Center", TabPanel1);
		TabPanel1p[0].add("Center", Panel3);
		Panel3.setLayout(new BorderLayout());
		Panel3.add("Center", ChartLayout1);
		Panel1.add("South", JDPButtons1);
		Panel1.add("West", Panel4);
		Panel4.setLayout(new GridLayout(2,1));
		Panel4.add(ResultList1);
		Panel4.add(RichText1);

		Panel2.setFont(new Font("TimesRoman", Font.PLAIN, 11));
		Panel2.setForeground(user.u._cvtcolor("Blue"));
		Panel2.setBackground(user.u._cvtcolor("Magenta"));
		TabPanel1.setTabcolor(0,user.u._cvtcolor("Black"), user.u._cvtcolor("LightGray"));
		Panel3.setFont(new Font("Helvetica", Font.PLAIN, 11));
		Panel3.setForeground(user.u._cvtcolor("Black"));
		Panel3.setBackground(user.u._cvtcolor("LightGray"));
		ChartLayout1.setBackground(user.u._cvtcolor("White"));
		popuppanel.addComponent(JDPButtons1.button[0] ,"Print to local printer" ,"Print to local printer");
		RichText1.setFont(new Font("Helvetica", Font.BOLD, 11));
		RichText1.setText("NOTE: This demo requires the JPrinter classes to be installed in the following directory under the JDesignerPro directory:   com.bristol.jpclient   Download JPrinter from www.bristol.com.");


		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(JDPButtons1.button[0])) {
				if (JpPrintJob1.openPrinter(null, JpPrinterProperties1) == false) return true;
				
				
				JpPrintJob1.setMatch(1152, 900, 325, 254);
				
				JpPrintGraphics1 = JpPrintJob1.getGraphics();
				
				JpPrintJob1.startDocument();
				JpPrintJob1.startPage();
				
				ChartLayout1.paint(JpPrintGraphics1);
				
				JpPrintJob1.endPage();
				JpPrintJob1.endDocument();
				JpPrintJob1.closePrinter();
				
				
				return true;
			}
			if (e.target.equals(ResultList1)) {
				ChartLayout1LoadData(ResultList1.getSelectedKey());
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		JpPrintGraphics1 = JpPrintJob1.getGraphics();

	}

com.bristol.jpclient.JpPrintGraphics JpPrintGraphics1;	//
	//  Main initialization method
	//
	public void ChartLayout1Main() {

		ChartLayout1SetChartParms();
		ChartLayout1LoadData(null);

	}

	//
	//  Load the parameters for the selected chart
	//
	public void ChartLayout1SetChartParms() {

		JDPChartParms p;
		if (ChartLayout1 == null) {
			p = new JDPChartParms();
			ChartLayout1 = new JDPChart(user, p);
		} else {
			p = ChartLayout1.p;
		}

		p.chartType = 5;
		p.autoscale = true;
		p.autozoom = true;

		p.chartTitle = "SALES CHART";
		p.chartTitleFont = user.boldFont.getName();
		p.chartTitleColor = user.u._cvtcolor("Black");

		p.xaxisTitle = "";
		p.xaxisTitleFont = user.boldFont.getName();
		p.xaxisTitleColor = user.u._cvtcolor("Black");

		p.yaxisLabel = new String[10];

		p.elementLegendFont = user.boldFont.getName();

		p.xaxisLabelColor = user.u._cvtcolor("Black");
		p.yaxisLabelColor = user.u._cvtcolor("Black");
		p.chartFrameColor = user.u._cvtcolor("Black");

		p.elementLegend = new String[1];
		p.elementColor = new Color[1];
		p.elementBorderColor = new Color[1];
		p.elementLegend[0] = "Qty";
		p.elementColor[0] = user.u._cvtcolor("Magenta");
		p.elementBorderColor[0] = user.u._cvtcolor("Black");

		p.gridLineSetting = JDPChart.HORIZONTAL + JDPChart.VERTICAL + JDPChart.FOREGROUND + JDPChart.BACKGROUND;
		p.gridColor = user.u._cvtcolor("Gray");

		p.maxPlotValue = 100;
		p.minPlotValue = 0;

		if ((p.chartType == JDPChart.COLUMN) || (p.chartType == JDPChart.BAR) ||
			(p.chartType == JDPChart.AREA)) {
			p.autozoom = false;
		}

		p.pieLabel = p.elementLegend;
		p.pieLabelColor = p.xaxisTitleColor;

	}

	//
	//  Load the selected item
	//
	public void ChartLayout1LoadData(String[] keys) {

		JDPChartParms p = ChartLayout1.p;

		StringTokenizer stok;
		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		int actualRows = 0;
		String row;
		String whereClause = "(1=1)";

		int groupCount = 1;
		int seriesCount = 0;

		if (keys != null && keys.length > 0 && keys[0] != null) whereClause += " AND stor_id='" + keys[0]+ "'" ;
		if (keys != null && keys.length > 1 && keys[1] != null) whereClause += " AND ord_num='" + keys[1]+ "'" ;
		if (keys != null && keys.length > 2 && keys[2] != null) whereClause += " AND title_id='" + keys[2]+ "'" ;
		String SQL = "SELECT LEFT(format(ord_date, 'yy/mm/dd'),5),SUM(qty) FROM dbo_sales  WHERE " + whereClause + " GROUP BY LEFT(format(ord_date, 'yy/mm/dd'),5) ORDER BY SUM(qty) DESC";


		user.mainmsg.setStatusMsg("Accessing database...", 0);

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setCSTR("DSN=JDP Tutorial;UID=;PWD=;");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		recCount = jaggSQL.execSQL(SQL, results);

		if(recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return;
		}
		if(recCount == 0) {
			user.mainmsg.setStatusMsg("No records found that match the selected criteria",10);
			ChartLayout1.hide();
			return;
		}
		ChartLayout1.show();

		//
		//  Initialise result arrays
		//
		int columnCount = jaggSQL.getColumnCount();
		actualRows = jaggSQL.getRowCount();

		if (seriesCount <= 0) {
			p.chartData = new float[columnCount-groupCount][actualRows];
			p.xaxisLabel = new String[actualRows];
			p.piechartData = new float[actualRows];
			p.pieSplitSegment = new boolean[actualRows];
			p.pieLabel = new String[actualRows];
			if (p.chartType == JDPChart.PIE) {
				p.elementColor = new Color[actualRows];
				p.elementBorderColor = new Color[actualRows];
 				p.elementLegend = new String[actualRows];
			}
			for (int ix=0; ix<actualRows; ix++) {
				row = (String)results.elementAt(ix);
				stok = new StringTokenizer(row);
				p.xaxisLabel[ix] = "";
				if (groupCount > 0) p.xaxisLabel[ix] = stok.nextToken(sep).trim();
				for (int iz=0; iz<columnCount-groupCount; iz++) {
					p.chartData[iz][ix] = Float.valueOf(stok.nextToken(sep).trim()).floatValue();
				}
				p.pieLabel[ix] = p.xaxisLabel[ix];
				p.piechartData[ix] = p.chartData[0][ix];
				if (p.chartType == JDPChart.PIE) {
					p.elementColor[ix] = JDPUtils.colorList[ix%12];
					p.elementBorderColor[ix] = Color.black;
 					p.elementLegend[ix] = p.pieLabel[ix];
				}
			}
		} else {
			float[][] tempchartData = new float[1000][actualRows];
			p.xaxisLabel = new String[actualRows];
			Vector group = new Vector();
			if (groupCount == 0) group.addElement("");
			Vector series = new Vector();
			for (int ix=0; ix<actualRows; ix++) {
				row = (String)results.elementAt(ix);
				stok = new StringTokenizer(row);
				p.xaxisLabel[ix] = "";
				int groupIndex = 0;
				if (groupCount > 0) {
					String groupValue = stok.nextToken(sep).trim();
					groupIndex = group.indexOf(groupValue);
					if (groupIndex < 0) {
						group.addElement(groupValue);
						groupIndex = group.indexOf(groupValue);
						p.xaxisLabel[groupIndex] = groupValue;
					}
				}
				String seriesValue = stok.nextToken(sep).trim();
				int seriesIndex = series.indexOf(seriesValue);
				if (seriesIndex < 0) {
					series.addElement(seriesValue);
					seriesIndex = series.indexOf(seriesValue);
				}
				tempchartData[seriesIndex][groupIndex] = Float.valueOf(stok.nextToken(sep).trim()).floatValue();
			}

			int numbars = series.size();
			p.chartData = new float[numbars][group.size()];
			for (int ix=0; ix<numbars; ix++) {
				for (int iy=0; iy<group.size(); iy++) {
					p.chartData[ix][iy] = tempchartData[ix][iy];
				}
			}
			p.elementColor = new Color[numbars];
			p.elementBorderColor = new Color[numbars];
 			p.elementLegend = new String[numbars];
			for (int ix=0; ix<numbars; ix++) {
				p.elementColor[ix] = JDPUtils.colorList[ix%12];
				p.elementBorderColor[ix] = Color.black;
 				p.elementLegend[ix] = (String)series.elementAt(ix);
			}
		}
		ChartLayout1.calculateScaling();
		ChartLayout1.repaint();

		user.mainmsg.clearStatusMsg();
	}

	//
	//  Create and load the Result List Panel
	//
	public void ResultList1Main() {

		String ResultList1sf = "stor_id";
		String[] ResultList1df = {};
		String ResultList1wc = "(1=1)";
		String[] ResultList1sct = {"Store  name"};
		String[] ResultList1sc = {"stor_name"};
		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setCSTR("DSN=JDP Tutorial;UID=;PWD=;");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");
		ResultList1 = new JDPSearchResults(user, targetPanel, true, jaggSQL, false, ResultList1sf, ResultList1df, ResultList1wc, ResultList1sct, ResultList1sc, ResultList1sc, "", true, "Total Entries:");
		int[] ResultList1icons = new int[3];
		ResultList1icons[0] = 3;
		ResultList1icons[1] = 5;
		ResultList1.setMinWidth(200);
		ResultList1.setIcons(ResultList1icons);
		ResultList1.setFromWhereClause(" FROM dbo_stores WHERE (1=1)");
		ResultList1.clearList("");
		ResultList1.loadList();
	}


}

